Main Page Namespace List Class Hierarchy Alphabetical List Compound List File List Compound Members File Members

# gnRAWSource Class Reference

gnRAWSource reads raw sequence data from a text file. More...

`#include <gnRAWSource.h>`

Inheritance diagram for gnRAWSource::

List of all members.

## Public Methods
| gnRAWSource ()
| Empty Constructor, does nothing. More...
| gnRAWSource (const gnRAWSource &s)
| Clone Constructor copies the specified gnRAWSource. More...
| ~gnRAWSource ()
| Destructor, frees memory. More...
gnRAWSource* | Clone () const
| Returns an exact copy of this class. More...
uint32 | GetContigListLength () const
| Get the number of sequence contigs in this source. More...
boolean | HasContig (const string &name) const
| Looks for a contig by name. More...
uint32 | GetContigID (const string &name) const
| Get a contig index by name. More...
string | GetContigName (const uint32 i) const
| Get the name of the specified contig. More...
gnSeqI | GetContigSeqLength (const uint32 i) const
| Get the total number of base pairs in the specified contig. More...
boolean | SeqRead (const gnSeqI start, char *buf, uint32 &bufLen, const uint32 contigI=ALL_CONTIGS)
| Gets sequence data from this source. More...
gnGenomeSpec* | GetSpec () const
| Get the annotated sequence data as a gnGenomeSpec. More...
gnFileContig* | GetFileContig (const uint32 contigI) const
| Returns a pointer to the file contig corresponding to contigI or null if none exists. More...
## Static Public Methods
boolean | Write (gnSequence &sequence, const string &filename)
| Writes the specified gnSequence to a raw file named "filename". More...
boolean | Write (gnBaseSource *source, const string &filename)
| Writes the specified source to a raw file named "filename". More...
## Private Methods
boolean | SeqSeek (const gnSeqI start, const uint32 &contigI, uint64 &startPos, uint64 &readableBytes)
boolean | SeqStartPos (const gnSeqI start, gnFileContig &contig, uint64 &startPos, uint64 &readableBytes)
boolean | ParseStream (istream &fin)
## Private Attributes
gnFileContig* | m_contig
gnGenomeSpec* | m_spec

## Detailed Description

gnRAWSource reads raw sequence data from a text file.

This class reads and writes raw sequence to and from files. A raw sequence does not contain any newlines, fragment delimiters, or other type of annotation. gnRAWSource is used by gnSourceFactory to read files and should only be used directly.when writing out raw files by calling gnRAWSource::Write( mySpec, "C:\myFile.txt");

Definition at line 36 of file gnRAWSource.h.

## Constructor & Destructor Documentation

gnRAWSource::gnRAWSource ( | )

| Empty Constructor, does nothing. Definition at line 21 of file gnRAWSource.cpp. Referenced by Clone().

gnRAWSource::gnRAWSource ( | const gnRAWSource & s )

  | Clone Constructor copies the specified gnRAWSource. Parameters:
  s | The gnRAWSource to copy.
Definition at line 27 of file gnRAWSource.cpp.

gnRAWSource::~gnRAWSource ( | )

| Destructor, frees memory. Definition at line 33 of file gnRAWSource.cpp.

## Member Function Documentation

gnRAWSource * gnRAWSource::Clone ( | ) const`[inline, virtual]`

| Returns an exact copy of this class. Reimplemented from gnFileSource. Definition at line 91 of file gnRAWSource.h. Referenced by gnRAWSource().

uint32 gnRAWSource::GetContigID ( | const string & name ) const`[virtual]`

  | Get a contig index by name. If the source does not contain a contig by the specified name GetContigID returns UINT32_MAX. Parameters:
  name | The name of the contig to look for.
Returns: The index of the named contig or UINT32_MAX. Reimplemented from gnBaseSource. Definition at line 46 of file gnRAWSource.cpp.

uint32 gnRAWSource::GetContigListLength ( | ) const`[inline, virtual]`

| Get the number of sequence contigs in this source. Returns: The number of contigs in this source. Reimplemented from gnBaseSource. Definition at line 97 of file gnRAWSource.h.

string gnRAWSource::GetContigName ( | const uint32 i ) const`[virtual]`

  | Get the name of the specified contig. Returns an empty string if the specified contig is out of range. Parameters:
  i | The index of the contig or ALL_CONTIGS.
Returns: The name of the contig or an empty string. Reimplemented from gnBaseSource. Definition at line 51 of file gnRAWSource.cpp.

gnSeqI gnRAWSource::GetContigSeqLength ( | const uint32 i ) const`[virtual]`

  | Get the total number of base pairs in the specified contig. Parameters:
  i | The index of the contig or ALL_CONTIGS.
Returns: The length in base pairs of the specified contig. Reimplemented from gnBaseSource. Definition at line 56 of file gnRAWSource.cpp.

gnFileContig * gnRAWSource::GetFileContig ( | const uint32 contigI ) const`[virtual]`

| Returns a pointer to the file contig corresponding to contigI or null if none exists. Reimplemented from gnFileSource. Definition at line 93 of file gnRAWSource.cpp.

gnGenomeSpec * gnRAWSource::GetSpec ( | ) const`[virtual]`

| Get the annotated sequence data as a gnGenomeSpec. GetSpec returns a gnGenomeSpec which contains the sequence, header, and feature data contained by this source. Returns: The annotated sequence data. Reimplemented from gnBaseSource. Definition at line 67 of file gnRAWSource.cpp.

boolean gnRAWSource::HasContig ( | const string & name ) const`[virtual]`

  | Looks for a contig by name. Returns true if it finds the contig, otherwise false. Parameters:
  name | The name of the contig to look for.
Returns: True if the named contig exists, false otherwise. Reimplemented from gnBaseSource. Definition at line 39 of file gnRAWSource.cpp.

boolean gnRAWSource::ParseStream ( | istream & fin )`[private, virtual]`

| Reimplemented from gnFileSource. Definition at line 100 of file gnRAWSource.cpp.

boolean gnRAWSource::SeqRead ( | const gnSeqI start,
| char * buf,
| uint32 & bufLen,
| const uint32 contigI = ALL_CONTIGS )`[virtual]`

  | Gets sequence data from this source. SeqRead will attempt to read "bufLen" base pairs starting at "start", an offset into the sequence. Reading inside a specific contig can be accomplished by supplying the "contigI" parameter with a valid contig index. SeqRead stores the sequence data in "buf" and returns the actual number of bases read in "bufLen". SeqRead will return false if a serious error occurs. Parameters:
  start | The base pair to start reading at.
  buf | The character array to store base pairs into.
  len | The number of base pairs to read.
  contigI | The index of the contig to read or ALL_CONTIGS by default.
Returns: True if the operation was successful. Reimplemented from gnBaseSource. Definition at line 63 of file gnRAWSource.cpp.

boolean gnRAWSource::SeqSeek ( | const gnSeqI start,
| const uint32 & contigI,
| uint64 & startPos,
| uint64 & readableBytes )`[private]`

boolean gnRAWSource::SeqStartPos ( | const gnSeqI start,
| gnFileContig & contig,
| uint64 & startPos,
| uint64 & readableBytes )`[private]`

boolean gnRAWSource::Write ( | gnBaseSource * source,
| const string & filename )`[inline, static]`

  | Writes the specified source to a raw file named "filename". Parameters:
  source | The source to write out.
  filename | The name of the file to write.
Returns: True if successful, false otherwise. Definition at line 102 of file gnRAWSource.h.

boolean gnRAWSource::Write ( | gnSequence & sequence,
| const string & filename )`[static]`

  | Writes the specified gnSequence to a raw file named "filename". Parameters:
  source | The gnSequence to write out.
  filename | The name of the file to write.
Returns: True if successful, false otherwise. Definition at line 71 of file gnRAWSource.cpp. Referenced by Write().

## Member Data Documentation

gnFileContig * gnRAWSource::m_contig`[private]`

| Definition at line 86 of file gnRAWSource.h.

gnGenomeSpec * gnRAWSource::m_spec`[private]`

| Definition at line 87 of file gnRAWSource.h.

The documentation for this class was generated from the following files:

- gnRAWSource.h
- gnRAWSource.cpp